;͸
;The Wrath of Zalthar v0.1s                                                  
; (C)1996/97 by Andreas Ess                                                     
;;
#include "ti-85.h"

POSY  =   TEXT_MEM      ;position on map
POSX  =   TEXT_MEM+1
RELY  =   TEXT_MEM+2    ;relative position
RELX  =   TEXT_MEM+3
SCREEN =  TEXT_MEM+4
MAGIC =   TEXT_MEM+5
POWER =   TEXT_MEM+6
GOLD  =   TEXT_MEM+7
SCROFSX = TEXT_MEM+8    ;left upper corner of map
SCROFSY = TEXT_MEM+9
PARTY =   TEXT_MEM+10   ;who's the second one?
MAGIC2 =  TEXT_MEM+11   ;his magic & power
POWER2 =  TEXT_MEM+12
GOLD2  =  TEXT_MEM+13
GUYPT =	  TEXT_MEM+14	;who's the second guy(image pointer)

GrafxPt   = TEXT_MEM2
Color     = TEXT_MEM2+2
Data      = TEXT_MEM2+3
KEYPRESS  = TEXT_MEM2+4

ScrXSize = 12
ScrYSize = 5

.org 0
TitleStr:
.db "The Wrath of Zalthar",0

StartGame:
 ld	hl, (PROGRAM_ADDR)
 ld	de, Graphics
 add	hl, de
 ld   	(GrafxPt), hl
 ld   	hl, 0
 ld   	(SCROFSX), hl
 set  	3, (iy+05)
 CALL_(GrayScaleOn)
;** Title:
 CALL_(ClrScr)
 ld	hl, (PROGRAM_ADDR)
 ld	de, TitlePic
 add	hl, de
 ld   	bc, 0
 CALL_(DeGCP)
WaitKey:
 call 	GET_KEY
 and  	a
 jr 	z, WaitKey
 cp   	K_F1
 jr 	z, StartNewGame
 cp   	K_F2
 jr 	nz, WaitKey
StartNewGame:
 CALL_(ClrScr)
 ld	hl, $0010
 ld	($8333), hl
 ld	hl, (PROGRAM_ADDR)
 ld	de, Select
 add	hl, de
 ROM_CALL(D_ZM_STR)
 ld	c, 1
 jr	DrawMember
SelectLoop:
 call	GET_KEY
 cp	K_ENTER
 jr	z, Selected
 cp	K_UP
 jr	z, NextMember
 cp	K_DOWN
 jr	nz, SelectLoop
NextMember:
 dec	c
 jr	nz, DrawMember
 ld	c, 4
DrawMember:
 ld	h, 0
 ld	l, c
 dec	l
 add	hl, hl
 add	hl, hl
 add	hl, hl
 add	hl, hl
 add	hl, hl
 add	hl, hl
 ld	de, (PROGRAM_ADDR)
 add	hl, de
 ld	de, Ritter
 add	hl, de
 ex	de, hl
 push	bc
 ld	bc, $0001
 CALL_(Sprite16)
 pop	bc
 ld	hl, (PROGRAM_ADDR)
 ld	de, MemberData
 add	hl, de
 ld	de, 12
 ld	b, c
GetData:
 add	hl, de
 djnz	GetData
 ld	de, $2808
 ld	($8333), de
 ROM_CALL(D_ZM_STR)
 ld	b, 4
TextLoop:
 push	hl
 ld	l, (hl)
 ld	h, 0
 call	M_HL_DECI
 pop	hl
 inc	hl
 ld	a, ($8334)
 add	a, 6
 ld	($8334), a
 ld	a, $28
 ld	($8333), a
 djnz	TextLoop
 jr	SelectLoop
Selected:
 ld	a, c
 ld	(PARTY), a
 CALL_(ClrScr)
 ld	hl, (PROGRAM_ADDR)
 ld	de, GameScreen
 add	hl, de
 ld   	bc, 0
 CALL_(DeGCP)
 set  	3, (iy+05)
 ld   	de, Menu_Normal
 CALL_(WriteMenu)
 ld	hl, (PROGRAM_ADDR)
 ld	de, MountainMap
 add	hl, de
 push 	hl
 pop  	ix
 CALL_(DecompMap)
 ld   	hl, $0502
 ld   	(POSY), hl
 ld   	bc, $0A02
 JUMP_(RedrawScene)

;
;The GAMEdjnz
;
Gamedjnz:
 halt
 call 	GET_KEY
 and  	a
 jr   	z, Gamedjnz
 ld   	(KEYPRESS), a
 cp   	K_LEFT
 jr 	nz, TestRight
 ld   	hl, POSX
 ld   	a, (hl)
 and  	a
 jr 	z,   TestRight
 dec  	(hl)
 CALL_(RetField)
 jr	nc, TestLeft_No
 dec  	b
 ld   	a, b
 cp   	6
 jr	nc, TestRight
 ld   	a, (SCROFSX)
 and  	a
 jr 	z, TestRight
 inc  	b
 dec  	a
 ld   	(SCROFSX), a
 jr   	TestRight
TestLeft_No:
 inc  	(hl)
TestRight:
 ld   	a, (KEYPRESS)
 cp   	K_RIGHT
 jr 	nz, TestUp
 ld   	hl, POSX
 ld   	a, (hl)
 cp   	39
 jr 	z, TestUp
 inc  	(hl)
 CALL_(RetField)
 jr	nc, TestRight_No
 inc  	b
 ld   	a, b
 cp   	12
 jr	c, TestUp
 ld   	a, (SCROFSX)
 cp  	29
 jr 	z, TestRight
 dec  	b
 inc  	a
 ld   	(SCROFSX), a
 jr   	TestUp
TestRight_No:
 dec  	(hl)
TestUp:
 ld   	a, (KEYPRESS)
 cp   	K_UP
 jr 	nz, TestDown
 ld   	hl, POSY
 ld   	a, (hl)
 and  	a
 jr 	z, TestDown
 dec  	(hl)
 CALL_(RetField)
 jr	nc, TestUp_No
 dec  	c
 ld   	a, c
 cp   	1
 jr	nc, TestDown
 ld   	a, (SCROFSY)
 and  	a
 jr 	z, TestDown
 inc  	c
 dec  	a
 ld   	(SCROFSY), a
 jr   	TestDown
TestUp_No:
 inc  	(hl)
TestDown:
 ld   	a, (KEYPRESS)
 cp   	K_DOWN
 jr 	nz,  TestSpells
 ld   	hl, POSY
 ld   	a, (hl)
 cp   	19
 jr 	z, TestSpells
 inc  	(hl)
 CALL_(RetField)
 jr	nc, TestDown_No
 inc  	c
 ld   	a, c
 cp   	4
 jr	c, TestSpells
 ld   	a, (SCROFSY)
 cp   	14
 jr 	z, TestSpells
 dec  	c
 inc  	a
 ld   	(SCROFSY), a
 jr   	TestSpells
TestDown_No:
 dec  	(hl)
TestSpells:
 ld   	a, (KEYPRESS)
 cp   	K_F1
 jr 	nz, TestUse1
TestUse1:
 cp   	K_F2
 jr 	nz,  TestInv1
TestInv1:
 cp   	K_F3
 jr 	nz,  TestInv2
TestUse2:
 cp   	K_F4
 jr 	nz,  TestInv2
TestInv2:
 cp   	K_F5
 jr 	nz,  TestExit
TestExit:
 cp   	K_EXIT
 jr 	z,   ExitGame
TestSave:
 cp   	K_ENTER
 jr 	nz,  RedrawScene
RedrawScene:
 CALL_(TownMap)
 ld   	hl, (PROGRAM_ADDR)
 ld   	de, Zalthar
 add  	hl, de
 ex   	de, hl
 CALL_(Sprite8)
 ld   	a, r
 cp   	7
 jr	nc, J2Gamedjnz
 CALL_(Enemy)
J2Gamedjnz:
 JUMP_(Gamedjnz)

ExitGame:
 CALL_(GrayScaleOff)
 ret

;
;WriteMenu
;
WriteMenu:
 ld  	hl, (PROGRAM_ADDR)
 add 	hl, de
 ld  	de, $3A02
 ld  	($8333), de
 ROM_CALL(D_ZM_STR)
 ld  	c, $22
 ld  	de, $3A22
 ld  	($8333), de
 ld  	b, 4
MenuLoop:
 ROM_CALL(D_ZM_STR)
 ld  	a, c
 add 	a, 24
 ld  	c, a
 ld  	($8333), a
 djnz	MenuLoop
 ret

;
;Enemy
;
Enemy:
 push	bc
;First, redraw whole screen.
 CALL_(ClrScr)
 ld	hl, (PROGRAM_ADDR)
 ld	de, GameScreen
 add	hl, de
 ld   	bc, 0
 CALL_(DeGCP)
 ld   	hl, (Page1K)
 ld   	d, h
 ld   	e, l
 inc  	de
 ld   	(hl), 15
 ld   	bc, 799
 ldir
 CALL_(TownMap)
 ld   	de, Menu_Fight
 CALL_(WriteMenu)
 ld	hl, (PROGRAM_ADDR)
 ld	de, Zalthar
 add	hl, de
 ld	b,
 CALL_(Sprite8)
;action gone, redraw original map
 pop	bc
 ret

;
;DispText
;
DispText:
 ld  ($8333), hl
 ld  hl, (PROGRAM_ADDR)
 add hl, de
 ROM_CALL(D_ZM_STR)
 ret

;
;RetField
;
RetField:
 push bc
 push hl
 ld   bc, (POSY)
 ld   hl, (Page1K)
 ld   de, 40
 ld   a, c
 and  a
 jr   z, RetFieldDone
RetFielddjnz:
 add  hl, de
 dec  c
 jr   nz, RetFielddjnz
RetFieldDone:
 ld   e, b
 add  hl, de
 ld   a, (hl)
 pop  hl
 pop  bc
 cp   16
 ret

;
;ClrScr: clear inactive page at (Page1Addr) & (Page2Addr)
;
ClrScr:
 ld   hl, (Page1Addr)
 ld   d, h
 ld   e, l
 inc  de
 ld   (hl), 0
 ld   bc, 1023
 ldir
 ld   hl, (Page2Addr)
 ld   d, h
 ld   e, l
 inc  de
 ld   (hl), 0
 ld   bc, 1023
 ldir
 ret

;
;DecompMap decompresses map at IX -> Page1K
;
DecompMap:
 ld   hl, (Page1K)
 ld   de, 800
Decompdjnz:
 ld   a, (ix)
 cp   193
 jr   c, NoRLE
 sub  192
 ld   b, a
 inc  ix
 ld   a, (ix)
RLEdjnz:
 ld   (hl), a
 inc  hl
 dec  de
 djnz RLEdjnz
 jr   Decompdjnz_1
NoRLE:
 ld   (hl), a
 inc  hl
 dec  de
Decompdjnz_1:
 inc  ix
 ld   a, d
 or   e
 jr nz,  Decompdjnz
 ret

;
;Draws a 'town'-map: Map -> (Page1K), Basepicture -> GrafxPt
;
TownMap:
 push bc
 ld   bc, (SCROFSX)
 ld   hl, (Page1K)
 ld   de, 40
 ld   a, b
 and  a
 jr z,   TM_NoAddY
TownMapAddY:
 add  hl, de
 djnz TownMapAddY
TM_NoAddY
 add  hl, bc
 ld   de, (GrafxPt)
 ld   c, 0
TownMap_Ydjnz:
 ld   b, 5
TownMap_Xdjnz:
 push de
 ld   a, (hl)
 push hl
 ld   h, 0
 ld   l, a
 add  hl, hl
 add  hl, hl
 add  hl, hl
 add  hl, hl
 add  hl, de
 ex   de, hl
 pop  hl
 CALL_(Sprite8)
 pop  de
 inc  hl
 inc  b
 ld   a, b
 cp   15
 jr nz,  TownMap_Xdjnz
 push de
 ld   de, 30
 add  hl, de
 pop  de
 inc  c
 ld   a, c
 cp   5
 jr nz,  TownMap_Ydjnz
 pop  bc
 ret

;
;Sprite8: draws sprite %DE at (B*8,C*8)
;
Sprite8:
 push hl
 push bc
 push de
 pop  ix
;calculate offset
 ld   h, c             ;calculate offset: HL = C*16+B
 ld   l, 0
 srl  h
 rr   l
 ld   d, 0
 ld   e, b
 add  hl, de
 ld   b, h
 ld   c, l
 ld   hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 ld   hl, (Page1Addr)
 add  hl, bc
 ld   b, 8
Sprite8L1:
 ld   a, (ix)
 ld   (hl), a
 ld   a, (ix+8)
 ld   (de), a
 push bc
 ld   bc, 16
 add  hl, bc
 ex   de, hl
 add  hl, bc
 ex   de, hl
 pop  bc
 inc  ix
 djnz Sprite8L1
 pop  bc
 pop  hl
 ret

;
;Sprite16: draws sprite %DE at (B*8,C*8)
;
Sprite16:
 push hl
 push bc
 push de
 pop  ix
;calculate offset
 ld   h, c             ;calculate offset: HL = C*16+B
 ld   l, 0
 srl  h
 rr   l
 ld   d, 0
 ld   e, b
 add  hl, de
 ld   b, h
 ld   c, l
 ld   hl, (Page2Addr)
 add  hl, bc
 ex   de, hl
 ld   hl, (Page1Addr)
 add  hl, bc
 ld   b, 16
Sprite16L1:
 ld   a, (ix)
 ld   (hl), a
 ld   a, (ix+32)
 ld   (de), a
 inc  ix
 inc  de
 inc  hl
 ld   a, (ix)
 ld   (hl), a
 ld   a, (ix+32)
 ld   (de), a
 push bc
 ld   bc, 15
 add  hl, bc
 ex   de, hl
 add  hl, bc
 ex   de, hl
 pop  bc
 inc  ix
 djnz Sprite16L1
 pop  bc
 pop  hl
 ret

;
;Data:
;
Menu_Normal:
 .db "ITEM",0,"USE",0,"INV.",0
 .db "USE",0,"INV.",0

Menu_Fight:
 .db "SPELL",0,"FIGHT",0,"MAGIC",0
 .db "FIGHT",0,"MAGIC",0

Select:
 .db "SELECT A PARTY MEMBER:",0

GameScreen:
TitlePic:
 .db $5F,$44,$3F,$3F,$37,$45,$BA,$A0,$1C,$43,$3F,$3F,$38,$45,$BA,$84,$91
 .db $84,$91,$84,$91,$84,$91,$84,$91,$83,$A9,$3F,$3F,$36,$46,$BC,$3E,$8A
 .db $A9,$3F,$3F,$35,$BE,$A5,$AC,$A6,$99,$A6,$99,$A6,$99,$A6,$99,$A6,$99
 .db $8E,$44,$9A,$5F,$5F,$51,$BB,$A6,$AE,$5F,$BE,$A9,$3F,$3F,$34,$BB,$44
 .db $BA,$BB,$AE,$BB,$AE,$BB,$AE,$BB,$AE,$BB,$AE,$45,$3F,$3F,$35,$49,$31
 .db $0D,$AB,$44,$9A,$5F,$5F,$53,$26,$A5,$2A,$12,$5F,$5F,$5D,$23,$44,$27
 .db $17,$A5,$5F,$5F,$5E,$BA,$26,$18,$A5,$24,$A5,$3F,$3F,$31,$45,$BA,$A5
 .db $23,$19,$A9,$96,$3F,$3F,$35,$49,$24,$1A,$A5,$3F,$3F,$38,$49,$23,$1B
 .db $A6,$5F,$5F,$58,$63,$43,$BE,$23,$1B,$A5,$43,$BB,$7F,$7F,$75,$46,$94
 .db $1B,$A9,$AB,$5F,$5F,$55,$64,$45,$94,$1B,$A9,$9A,$BB,$7F,$7F,$72,$AB
 .db $64,$A9,$1D,$A9,$96,$A6,$5F,$5F,$59,$B8,$1D,$45,$96,$3F,$3F,$33,$44
 .db $9A,$A8,$1D,$47,$9A,$5F,$5F,$53,$23,$44,$1E,$AF,$63,$A6,$5F,$5F,$52
 .db $BA,$46,$1E,$43,$BE,$A6,$5F,$5F,$52,$BA,$A5,$96,$1E,$44,$B9,$3F,$3F
 .db $34,$A9,$25,$A0,$1C,$AB,$43,$99,$3F,$3F,$32,$A5,$23,$43,$1E,$44,$96
 .db $5F,$5F,$54,$99,$9A,$43,$1E,$AB,$A5,$A6,$5F,$5F,$5B,$1E,$46,$BB,$7F
 .db $7F,$72,$45,$BA,$A0,$1C,$A5,$A9,$5F,$5F,$5E,$1E,$44,$96,$5F,$5F,$5D
 .db $1E,$44,$23,$A5,$3F,$3F,$34,$46,$1E,$43,$24,$A5,$3F,$3F,$35,$AB,$B8
 .db $1D,$43,$24,$A5,$3F,$3F,$36,$AB,$B0,$1C,$BA,$3F,$3F,$3D,$43,$B0,$1C
 .db $BA,$24,$A5,$3F,$3F,$36,$44,$1E,$BA,$96,$5F,$5F,$55,$9A,$45,$B0,$1C
 .db $BA,$A6,$BB,$7F,$7F,$72,$28,$B0,$1C,$44,$9A,$5F,$5F,$54,$23,$44,$9C
 .db $1D,$BE,$A6,$5F,$5F,$5A,$BA,$B0,$1C,$BA,$96,$BB,$7F,$7F,$72,$43,$63
 .db $AB,$1D,$AE,$96,$5F,$5F,$5B,$BA,$B0,$19,$44,$96,$47,$9A,$46,$9A,$23
 .db $43,$25,$AE,$A9,$23,$44,$9A,$A5,$AB,$BA,$23,$4B,$96,$A9,$9A,$4A,$96
 .db $AB,$1C,$AB,$96,$44,$23,$49,$9A,$9A,$44,$23,$46,$23,$45,$9B,$B9,$AE
 .db $43,$9A,$44,$9A,$A6,$96,$44,$9A,$A9,$96,$AE,$A5,$23,$B0,$19,$43,$B0
 .db $0E,$3F,$90,$0E,$3F,$9C,$19,$44,$B0,$82,$44,$07,$76,$AF,$BB,$43,$B0
 .db $0E,$76,$AF,$BB,$43,$BC,$18,$45,$B0,$8A,$46,$05,$76,$AB,$AB,$AF,$A0
 .db $0E,$76,$AB,$AB,$AF,$A8,$16,$48,$03,$49,$04,$76,$AE,$BB,$43,$B0,$0E
 .db $76,$AE,$BB,$43,$B8,$14,$4A,$82,$4A,$03,$76,$AF,$BB,$AF,$B0,$0E,$76
 .db $AF,$BB,$AF,$B8,$11,$4D,$82,$4A,$03,$3F,$90,$0E,$3F,$98,$0F,$4F,$8A
 .db $4B,$83,$75,$AF,$BB,$43,$B0,$0E,$76,$AF,$BB,$43,$B8,$0D,$56,$9A,$9A
 .db $43,$83,$75,$AF,$BB,$AF,$A0,$0E,$76,$AF,$BB,$AF,$A8,$0A,$58,$9F,$8F
 .db $9A,$A0,$76,$45,$BA,$AC,$0F,$76,$45,$BA,$AE,$5F,$44,$06,$9A,$A0,$76
 .db $AF,$BB,$AF,$B0,$0E,$76,$AF,$BB,$AF,$B8,$1D,$45,$06,$9A,$43,$3F,$90
 .db $0E,$3F,$91,$84,$91,$84,$91,$84,$91,$84,$91,$84,$90,$8A,$A4,$84,$86
 .db $44,$3F,$90,$0E,$3F,$91,$3D,$81,$43,$9F,$B6,$45,$3F,$90,$0E,$3F,$92
 .db $99,$A6,$99,$A6,$99,$A6,$99,$A6,$99,$A4,$03,$A9,$03,$A9,$8A,$A5,$3E
 .db $10,$3F,$9A,$5E,$03,$96,$24,$81,$03,$3F,$90,$0E,$3F,$9A,$BB,$AE,$BB
 .db $AE,$BB,$AE,$BB,$AE,$BB,$AE,$10,$3F,$90,$0E,$3F,$90,$1F,$1F,$1F,$1F
 .db $03,$3D,$A8,$36,$A1,$35,$A1,$35,$A1,$35,$A1,$3B,$43,$85,$33,$A8,$35
 .db $A8,$35,$A8,$35,$A8,$3B,$44,$85,$32,$43,$85,$32,$43,$85,$32,$43,$85
 .db $32,$43,$85,$37,$46,$85,$31,$44,$85,$31,$44,$85,$31,$44,$85,$31,$44
 .db $85,$34,$49,$85,$2F,$46,$85,$2F,$46,$85,$2F,$46,$85,$2F,$46
 .db $00

Zalthar:
 .db $1C,$14,$36,$3E,$1C,$36,$22,$63
 .db $00,$08,$08,$7F,$1C,$36,$22,$63

Ritter:
 .db $03,$80,$05,$C0,$08,$E0,$11,$F0,$20,$F8,$23,$F8,$3F,$F8,$20,$08
 .db $24,$48,$20,$08,$11,$10,$17,$D0,$1B,$B0,$08,$20,$1F,$F0,$7F,$FC
 .db $03,$80,$06,$40,$0F,$20,$1E,$10,$3F,$08,$3C,$08,$3F,$F8,$20,$08
 .db $24,$48,$20,$08,$11,$10,$17,$D0,$18,$30,$08,$20,$E7,$CE,$80,$03

Henker:
 .db $03,$C0,$0F,$F0,$1F,$F8,$3F,$FC,$7F,$FE,$67,$E6,$73,$CE,$71,$8E
 .db $7F,$FE,$7F,$FE,$7F,$FE,$7F,$FE,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $03,$C0,$0C,$30,$10,$08,$20,$04,$58,$1A,$7C,$3E,$56,$6A,$51,$8A
 .db $4E,$72,$40,$02,$40,$02,$20,$04,$20,$04,$10,$08,$08,$10,$07,$E0

Woman:
 .db $03,$E0,$0F,$F8,$1F,$FE,$3F,$FF,$7F,$DF,$7D,$8F,$70,$07,$63,$33
 .db $E0,$03,$E0,$03,$E0,$02,$F0,$02,$F1,$E2,$F8,$04,$FC,$08,$FE,$10
 .db $00,$20,$00,$F8,$03,$FE,$07,$FF,$0F,$FF,$1F,$FF,$30,$0F,$23,$37
 .db $20,$07,$20,$07,$60,$06,$70,$0E,$71,$EE,$F8,$1C,$FC,$38,$FF,$F0

Wizard:
 .db $06,$60,$0C,$30,$18,$18,$38,$1C,$30,$0C,$26,$64,$20,$04,$20,$04
 .db $30,$0C,$38,$1C,$1F,$F8,$1F,$F8,$0F,$F0,$07,$E0,$03,$C0,$01,$80
 .db $06,$60,$0C,$30,$18,$18,$38,$1C,$30,$0C,$26,$64,$20,$04,$20,$04
 .db $30,$0C,$38,$1C,$1F,$F8,$1C,$38,$1F,$F8,$7F,$FE,$FF,$FF,$FF,$FF

MemberData:
;Format:(1 member=12 bytes)
;Name, zero terminated
;POWER
;LIVES
;MAGIC POINTS
;GOLD COINS
;TYPE
 .db "Rupert",0,15,16,4,10,1
 .db "Nikola",0,15,20,3,0,1
 .db "Ariane",0,12,11,6,30,2
 .db "Merlin",0,8,11,16,2,2

NameTxt:
 .db "NAME:",0
PowerTxt:
 .db "POWER:",0
LivesTxt:
 .db "LIVES:",0
MagicTxt:
 .db "MAGIC:",0
GoldTxt:
 .db "GOLD:",0

#include wozgray.asm
#include gcp.asm
#include wozmap.h

.end
